From ca4cd9f091086fbb38bbfc3611f1d3ec35bee130 Mon Sep 17 00:00:00 2001
From: Konstantin Oblaukhov <oblaukhov.konstantin@gmail.com>
Date: Sat, 11 Mar 2023 23:18:53 +0700
Subject: [PATCH 04/13] Si5342 driver for FD922.

---
 forward-v4l2/forward-v4l2-fd922.c |  76 +----
 forward/Makefile                  |   3 +-
 forward/forward-fd922.c           |  14 +
 forward/forward-si532x.c          |  28 +-
 forward/forward-si534x.c          | 454 ++++++++++++++++++++++++++++++
 forward/forward-si534x.h          |  24 ++
 6 files changed, 511 insertions(+), 88 deletions(-)
 create mode 100644 forward/forward-si534x.c
 create mode 100644 forward/forward-si534x.h

diff --git a/forward-v4l2/forward-v4l2-fd922.c b/forward-v4l2/forward-v4l2-fd922.c
index 950fd9c..56b7621 100644
--- a/forward-v4l2/forward-v4l2-fd922.c
+++ b/forward-v4l2/forward-v4l2-fd922.c
@@ -23,6 +23,7 @@
 
 #include <linux/delay.h>
 #include "forward-v4l2-ioctl.h"
+#include "forward-pll.h"
 
 #include "fd922_reg.h"
 
@@ -37,74 +38,6 @@
 
 #define FD922_ASI_PERIOD_REVISION 54
 
-inline void si53xx_select_bank(struct forward_dev *dev, u16 address)
-{
-	u8 bank = ((address >> 8) & 0xFF);
-	u8 tx[4] = { 0x00, 0x01, 0x40, bank };
-	dev->spi_xfer(dev, 4, tx, 32, NULL, 0);
-}
-
-static void si53xx_read_data(struct forward_dev *dev, u16 address, u8 *data, u8 count)
-{
-	u8 tx[2 + 8 * 2];
-	u8 rx[2 + 8 * 2];
-	int i;
-
-	si53xx_select_bank(dev, address);
-
-	tx[0] = 0x00;
-	tx[1] = (address & 0xFF);
-	for (i = 0; i < count; i++) {
-		tx[2 + i * 2] = 0xA0;
-		tx[2 + i * 2 + 1] = 0x00;
-	}
-	dev->spi_xfer(dev, 4, tx, (2 + count * 2) * 8, rx, (2 + count * 2) * 8);
-	for (i = 0; i < count; i++)
-		data[i] = rx[2 + i * 2 + 1];
-}
-
-static void si53xx_write_data(struct forward_dev *dev, u16 address, const u8 *data, u8 count)
-{
-	uint8_t tx[2 + 8 * 2];
-	int i;
-
-	si53xx_select_bank(dev, address);
-
-	tx[0] = 0x00;
-	tx[1] = (address & 0xFF);
-	for (i = 0; i < count; i++) {
-		tx[2 + i * 2] = 0x60;
-		tx[2 + i * 2 + 1] = data[i];
-	}
-	dev->spi_xfer(dev, 4, tx, (2 + count * 2) * 8, NULL, 0);
-}
-
-static void si53xx_write_n_div(struct forward_dev *dev, int channel, u64 num, u64 denom)
-{
-	u16 num_a, denom_a, up_a;
-	u8 data[8];
-	num_a = (channel == 0) ? 0x302 : 0x30d;
-	denom_a = (channel == 0) ? 0x308 : 0x313;
-	up_a = (channel == 0) ? 0x30c : 0x317;
-
-	data[0] = (num >> 0) & 0xff;
-	data[1] = (num >> 8) & 0xff;
-	data[2] = (num >> 16) & 0xff;
-	data[3] = (num >> 24) & 0xff;
-	data[4] = (num >> 32) & 0xff;
-	data[5] = (num >> 40) & 0xff;
-	si53xx_write_data(dev, num_a, data, 6);
-
-	data[0] = (denom >> 0) & 0xff;
-	data[1] = (denom >> 8) & 0xff;
-	data[2] = (denom >> 16) & 0xff;
-	data[3] = (denom >> 24) & 0xff;
-	si53xx_write_data(dev, denom_a, data, 4);
-
-	data[0] = 0xff;
-	si53xx_write_data(dev, up_a, data, 1);
-}
-
 static u32 fd922_irq_mask(const struct forward_v4l2_io *io)
 {
 	return (1 << (io->index * 3));
@@ -694,12 +627,7 @@ static s64 fd922_clock_deviation(struct forward_v4l2 *v4l2)
 
 static s64 fd922_set_clock_deviation(struct forward_v4l2 *v4l2, s64 ppt)
 {
-	u32 denom = 0xc8000000 + 0xc8000000LL * ppt / 1000000000000LL;
-
-	si53xx_write_n_div(v4l2->dev, 0, 0x2328000000ULL, denom);
-	si53xx_write_n_div(v4l2->dev, 1, 0x2331000000ULL, denom);
-
-	return 0;
+	return v4l2->dev->pll->ops->tune(v4l2->dev->pll, ppt);
 }
 
 struct forward_v4l2_dev_ops fd922_ops = {
diff --git a/forward/Makefile b/forward/Makefile
index 38ad428..f6a23e3 100644
--- a/forward/Makefile
+++ b/forward/Makefile
@@ -3,7 +3,8 @@ obj-m := forward.o
 forward-objs := forward-core.o forward-irq.o forward-ctl.o \
                 forward-vdma.o forward-fd788.o forward-fd722.o \
                 forward-fd720.o forward-fd922.o forward-fdio.o \
-                forward-fd940.o forward-fd2110.o forward-si532x.o
+                forward-fd940.o forward-fd2110.o forward-si532x.o \
+                forward-si534x.o
 
 SRC ?= $(PWD)
 KERNEL_SRC ?= /lib/modules/$(shell uname -r)/build
diff --git a/forward/forward-fd922.c b/forward/forward-fd922.c
index 1726d5a..f991803 100644
--- a/forward/forward-fd922.c
+++ b/forward/forward-fd922.c
@@ -20,6 +20,7 @@
 
 #include "forward.h"
 #include "forward-vdma.h"
+#include "forward-si534x.h"
 
 #include "fd922_reg.h"
 
@@ -80,11 +81,24 @@ static bool fd922_spi_xfer(struct forward_dev *dev, u8 bus, u8 *tx, int tx_bits,
 
 static int fd922_init(struct forward_dev *dev)
 {
+	struct forward_pll_mode *mode;
+
 	dev->spi_xfer = &fd922_spi_xfer;
+
+	forward_si534x_init(dev, &dev->pll, 4, 3);
+	mode = dev->pll->ops->find_mode(dev->pll, 0, 0, 148500000, false);
+	if (mode) {
+		printk("TEST SWITCH\n");
+		dev->pll->ops->switch_mode(dev->pll, mode);
+		dev->pll->ops->select_input(dev->pll, 0, true, false);
+		dev->pll->ops->calibrate(dev->pll);
+	}
+
 	return 0;
 }
 static void fd922_fini(struct forward_dev *dev)
 {
+	forward_si534x_fini(dev, &dev->pll);
 }
 
 static void fd922_read_id(struct forward_dev *dev)
diff --git a/forward/forward-si532x.c b/forward/forward-si532x.c
index 568d8e9..385a2ac 100644
--- a/forward/forward-si532x.c
+++ b/forward/forward-si532x.c
@@ -81,11 +81,11 @@ static int si532x_write_reg(struct forward_si532x *si532x, u8 reg, u8 data)
 					 &data);
 }
 
-static int si532x_read_reg(struct forward_si532x *si532x, u8 reg, u8 *data)
-{
-	return si532x->pll.dev->i2c_xfer(si532x->pll.dev, si532x->bus, true, si532x->address, reg,
-					 data);
-}
+//static int si532x_read_reg(struct forward_si532x *si532x, u8 reg, u8 *data)
+//{
+//	return si532x->pll.dev->i2c_xfer(si532x->pll.dev, si532x->bus, true, si532x->address, reg,
+//					 data);
+//}
 
 static int si532x_configure_factors(struct forward_si532x *si532x, u8 bwsel, u8 n1_hs, u32 nc1_ls,
 				    u8 n2_hs, u32 n2_ls, u32 n31, u32 n32)
@@ -217,22 +217,24 @@ static int si532x_select_input(struct forward_pll *pll, int input, bool master,
 	return 0;
 }
 
-int si532x_tune(struct forward_pll *pll, s64 ppt)
+static int si532x_tune(struct forward_pll *pll, s64 ppt)
 {
 	return -ENOTSUPP;
 }
 
-void si532x_calibrate(struct forward_pll *pll)
+static void si532x_calibrate(struct forward_pll *pll)
 {
 	struct forward_si532x *si532x = container_of(pll, struct forward_si532x, pll);
 	si532x_write_reg(si532x, 0x88, 0x40);
 }
 
-static struct forward_pll_ops si5324_ops = { .find_mode = si532x_find_mode,
-					     .switch_mode = si532x_switch_mode,
-					     .select_input = si532x_select_input,
-					     .tune = si532x_tune,
-					     .calibrate = si532x_calibrate };
+static struct forward_pll_ops si532x_ops = {
+	.find_mode = si532x_find_mode,
+	.switch_mode = si532x_switch_mode,
+	.select_input = si532x_select_input,
+	.tune = si532x_tune,
+	.calibrate = si532x_calibrate,
+};
 
 int forward_si532x_init(struct forward_dev *dev, struct forward_pll **pll, u8 bus, u8 address,
 			int num_inputs)
@@ -244,7 +246,7 @@ int forward_si532x_init(struct forward_dev *dev, struct forward_pll **pll, u8 bu
 	si532x->pll.dev = dev;
 	si532x->pll.features = FORWARD_PLL_FEATURE_FALLBACK;
 	si532x->pll.num_inputs = num_inputs;
-	si532x->pll.ops = &si5324_ops;
+	si532x->pll.ops = &si532x_ops;
 	si532x->bus = bus;
 	si532x->address = address;
 
diff --git a/forward/forward-si534x.c b/forward/forward-si534x.c
new file mode 100644
index 0000000..086e2b3
--- /dev/null
+++ b/forward/forward-si534x.c
@@ -0,0 +1,454 @@
+/*
+   forward-si534x.c - si534x PLL driver for SoftLab-NSK Forward boards
+
+   Copyright (C) 2017 - 2023 Konstantin Oblaukhov <oblaukhov@sl.iae.nsk.su>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License
+   as published by the Free Software Foundation; either version 2
+   of the License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*/
+
+#include "forward-pll.h"
+#include <linux/delay.h>
+
+struct forward_si534x {
+	struct forward_pll pll;
+
+	u8 bus;
+	u8 bank;
+};
+
+struct forward_si534x_mode {
+	int in_freq;
+	int pfd_freq;
+	bool m;
+	u64 Pn[3];
+	u32 Pd[3];
+	u64 Mn;
+	u32 Md;
+	u64 Bslow;
+	u64 Bfast;
+	u8 oof_div_sel[3];
+	u32 oof_ratio_ref[3];
+	u32 lol_clr_delay;
+	u32 hold_15m_cyc_count;
+	u16 pfd_en_delay;
+};
+/*
+const struct forward_si532x_mode forward_si532x_modes[] = {
+	{ 13500000 / 200, false, 5, 9, 4, 11, 7200, 1, 400 },
+	{ 13500000 / 200, true, 3, 9, 4, 11, 36000, 5, 2002 },
+	{ 13500000 / 240, false, 5, 9, 4, 11, 8640, 1, 480 },
+	{ 13500000 / 400, false, 5, 9, 4, 11, 14400, 1, 800 },
+	{ 13500000 / 400, true, 2, 9, 4, 11, 72000, 5, 4004 },
+	{ 13500000 / 480, false, 4, 9, 4, 11, 17280, 1, 960 },
+	{ 13500000 / 500, false, 4, 9, 4, 11, 18000, 1, 1000 },
+	{ 13500000 / 500, true, 4, 9, 4, 11, 18000, 1, 1001 },
+	{ 13500000 / 400, false, 5, 9, 4, 11, 14400, 1, 800 },
+	{ 13500000 / 400, true, 2, 9, 4, 11, 72000, 5, 4004 },
+	{ 13500000 / 480, false, 4, 9, 4, 11, 17280, 1, 960 },
+	{ 13500000 / 300, false, 5, 9, 4, 11, 10800, 1, 600 },
+	{ 13500000 / 300, true, 3, 9, 4, 11, 54000, 5, 3003 },
+	{ 13500000 / 360, false, 5, 9, 4, 11, 12960, 1, 720 },
+	{ 13500000 / 600, false, 4, 9, 4, 11, 21600, 1, 1200 },
+	{ 13500000 / 600, true, 2, 9, 4, 11, 108000, 5, 6006 },
+	{ 13500000 / 720, false, 4, 9, 4, 11, 25920, 1, 1440 },
+	{ 13500000 / 750, false, 4, 9, 4, 11, 27000, 1, 1500 },
+	{ 13500000 / 750, true, 3, 9, 4, 11, 54000, 2, 3003 },
+	{ 13500000 / 864, false, 3, 9, 4, 11, 31104, 1, 1728 },
+	{ 13500000 / 858, false, 3, 9, 4, 11, 30888, 1, 1716 },
+	{ 13500000 / 858, false, 3, 9, 4, 11, 30888, 1, 1716 },
+	{ 6750000, false, 10, 9, 4, 11, 288, 4, 16 },
+	{ 74250000, false, 10, 9, 4, 11, 288, 44, 16 },
+	{ 74250000, true, 8, 9, 4, 10, 1800, 250, 91 },
+	{ 148500000, false, 10, 9, 4, 11, 252, 77, 14 },
+	{ 148500000, true, 8, 9, 4, 10, 1800, 500, 91 },
+};
+*/
+const struct forward_si534x_mode si534x_default_mode = { -1,
+							 -1,
+							 false,
+							 { 1, 2640, 2640 },
+							 { 1, 1, 1 },
+							 0x00B9A000000000,
+							 0x80000000,
+							 0x07070F0F170F,
+							 0x0707090A2B18,
+							 { 1, 12, 12 },
+							 { 0x1111111, 0x1600000, 0x1600000 },
+							 0x0000E1AD,
+							 0x00E77C,
+							 0x03B3 };
+
+/*
+const int forward_si532x_modes_count =
+	sizeof(forward_si532x_modes) / sizeof(struct forward_si532x_mode);
+*/
+
+/*static int si532x_write_reg(struct forward_si532x *si532x, u8 reg, u8 data)
+{
+	return si532x->pll.dev->i2c_xfer(si532x->pll.dev, si532x->bus, false, si532x->address, reg,
+					 &data);
+}
+
+static int si532x_read_reg(struct forward_si532x *si532x, u8 reg, u8 *data)
+{
+	return si532x->pll.dev->i2c_xfer(si532x->pll.dev, si532x->bus, true, si532x->address, reg,
+					 data);
+}*/
+
+/*
+static int si532x_configure_factors(struct forward_si532x *si532x, u8 bwsel, u8 n1_hs, u32 nc1_ls,
+				    u8 n2_hs, u32 n2_ls, u32 n31, u32 n32)
+{
+	u32 reg_value;
+
+	if (bwsel > 15)
+		return -EINVAL;
+
+	if (n1_hs < 4 || n1_hs > 11)
+		return -EINVAL;
+
+	if (((nc1_ls != 1) && (nc1_ls % 2)) || (nc1_ls < 1) || (nc1_ls > (1 << 20)))
+		return -EINVAL;
+
+	if (n2_hs < 4 || n2_hs > 11)
+		return -EINVAL;
+
+	if (((n2_ls != 1) && (n2_ls % 2)) || (n2_ls < 1) || (n2_ls > (1 << 20)))
+		return -EINVAL;
+
+	if ((n31 < 1) || (n31 > (1 << 19)))
+		return -EINVAL;
+
+	if ((n32 < 1) || (n32 > (1 << 19)))
+		return -EINVAL;
+
+	si532x_write_reg(si532x, 0x02, (bwsel << 4) | (0x2));
+	si532x_write_reg(si532x, 0x19, ((n1_hs - 4) << 5));
+
+	reg_value = nc1_ls - 1;
+	si532x_write_reg(si532x, 0x1F, (reg_value >> 16) & 0x0F);
+	si532x_write_reg(si532x, 0x20, (reg_value >> 8) & 0xFF);
+	si532x_write_reg(si532x, 0x21, reg_value & 0xFF);
+
+	reg_value = n2_ls - 1;
+	si532x_write_reg(si532x, 0x28, ((n2_hs - 4) << 5) | ((reg_value >> 16) & 0x0F));
+	si532x_write_reg(si532x, 0x29, (reg_value >> 8) & 0xFF);
+	si532x_write_reg(si532x, 0x2A, reg_value & 0xFF);
+
+	reg_value = n31 - 1;
+	si532x_write_reg(si532x, 0x2B, (reg_value >> 16) & 0x07);
+	si532x_write_reg(si532x, 0x2C, (reg_value >> 8) & 0xFF);
+	si532x_write_reg(si532x, 0x2D, reg_value & 0xFF);
+
+	reg_value = n32 - 1;
+	si532x_write_reg(si532x, 0x2E, (reg_value >> 16) & 0x07);
+	si532x_write_reg(si532x, 0x2F, (reg_value >> 8) & 0xFF);
+	si532x_write_reg(si532x, 0x30, reg_value & 0xFF);
+
+	return 0;
+}
+*/
+/*
+static int si532x_load_defaults(struct forward_si532x *si532x)
+{
+	// PLL mode, CLK always on, no bypass
+	si532x_write_reg(si532x, 0x00, 0x34);
+	// CLKIN1 > CLKIN2 priority
+	//si532x_write_reg(si532x, 0x01, 0xE1);
+	// No output disabling during calibration, CLKIN2 selected
+	si532x_write_reg(si532x, 0x03, 0x55);
+	// Automatic clock selection, default hold history
+	//si532x_write_reg(si532x, 0x04, 0x92);
+	// LVDS outputs
+	si532x_write_reg(si532x, 0x06, 0x0F);
+	// External crystal as reference
+	si532x_write_reg(si532x, 0x07, 0x28);
+	// CLKOUT1 enabled, CLKOUT2 disabled
+	si532x_write_reg(si532x, 0x0A, 0x08);
+	// Frequency offset and phase error detector
+	si532x_write_reg(si532x, 0x13, 0x2F);
+	// Enable CK2_BAD, LOL, INT pins
+	si532x_write_reg(si532x, 0x14, 0x3B);
+	// Disable clock selection pins
+	si532x_write_reg(si532x, 0x15, 0xFC);
+	// Enable fast lock
+	si532x_write_reg(si532x, 0x89, 0x01);
+
+	return 0;
+}
+*/
+inline void si534x_select_bank(struct forward_si534x *si534x, u16 addr)
+{
+	u8 bank = ((addr >> 8) & 0xFF);
+	u8 tx[4] = { 0x00, 0x01, 0x40, bank };
+
+	if (si534x->bank != bank)
+		si534x->pll.dev->spi_xfer(si534x->pll.dev, si534x->bus, tx, 32, NULL, 0);
+	si534x->bank = bank;
+}
+
+inline void si534x_write_data(struct forward_si534x *si534x, u16 addr, const u8 *data, u8 count)
+{
+	u8 tx[2 + 16];
+	int i;
+
+	si534x_select_bank(si534x, addr);
+
+	tx[0] = 0x00;
+	tx[1] = (addr & 0xFF);
+	for (i = 0; i < count; i++) {
+		tx[2 + i * 2] = 0x60;
+		tx[2 + i * 2 + 1] = data[i];
+	}
+
+	si534x->pll.dev->spi_xfer(si534x->pll.dev, si534x->bus, tx, (2 + count * 2) * 8, NULL, 0);
+}
+
+//inline void si534x_read_data(struct forward_si534x *si534x, u16 addr, u8* data, u8 count)
+//{
+//	u8 tx[2 + 16];
+//	u8 rx[2 + 16];
+//	int i;
+//
+//	si534x_select_bank(si534x, addr);
+//
+//	tx[0] = 0x00;
+//	tx[1] = (addr & 0xFF);
+//	for (i = 0; i < count; i++) {
+//		tx[2 + i * 2] = 0xA0;
+//		tx[2 + i * 2 + 1] = 0x00;
+//	}
+//	si534x->pll.dev->spi_xfer(si534x->pll.dev, si534x->bus, tx, (2 + count * 2) * 8, rx, (2 + count * 2) * 8);
+//	for (i = 0; i < count; i++)
+//		data[i] = rx[2 + i * 2 + 1];
+//}
+
+static void si534x_write_reg_8(struct forward_si534x *si534x, u16 addr, u8 data)
+{
+	si534x_write_data(si534x, addr, &data, 1);
+}
+
+//static void si534x_read_reg_8(struct forward_si534x *si534x, u16 addr, u8 *data)
+//{
+//	si534x_read_data(si534x, addr, data, 1);
+//}
+
+static void si534x_write_reg_16(struct forward_si534x *si534x, u16 addr, u16 data)
+{
+	si534x_write_data(si534x, addr, (u8 *)&data, 2);
+}
+
+//static void si534x_read_reg_16(struct forward_si534x *si534x, u16 addr, u16 *data)
+//{
+//	si534x_read_data(si534x, addr, (u8*)data, 2);
+//}
+
+static void si534x_write_reg_24(struct forward_si534x *si534x, u16 addr, u32 data)
+{
+	si534x_write_data(si534x, addr, (u8 *)&data, 3);
+}
+
+//static void si534x_read_reg_24(struct forward_si534x *si534x, u16 addr, u32 *data)
+//{
+//	si534x_read_data(si534x, addr, (u8*)data, 3);
+//}
+
+static void si534x_write_reg_32(struct forward_si534x *si534x, u16 addr, u32 data)
+{
+	si534x_write_data(si534x, addr, (u8 *)&data, 4);
+}
+
+//static void si534x_read_reg_32(struct forward_si534x *si534x, u16 addr, u32 *data)
+//{
+//	si534x_read_data(si534x, addr, (u8*)data, 4);
+//}
+
+static void si534x_write_reg_48(struct forward_si534x *si534x, u16 addr, u64 data)
+{
+	si534x_write_data(si534x, addr, (u8 *)&data, 6);
+}
+
+//static void si534x_read_reg_48(struct forward_si534x *si534x, u16 addr, u64 *data)
+//{
+//	si534x_read_data(si534x, addr, (u8*)data, 6);
+//}
+
+static void si534x_write_reg_56(struct forward_si534x *si534x, u16 addr, u64 data)
+{
+	si534x_write_data(si534x, addr, (u8 *)&data, 7);
+}
+
+//static void si534x_read_reg_56(struct forward_si534x *si534x, u16 addr, u64 *data)
+//{
+//	si534x_read_data(si534x, addr, (u8*)data, 7);
+//}
+
+static struct forward_pll_mode *si534x_find_mode(struct forward_pll *pll, s64 in_freq,
+						 s64 common_in_freq, s64 out_freq, bool m)
+{
+	int i;
+
+	if (out_freq != 148500000)
+		return NULL;
+
+	if (in_freq <= 0) {
+		//if (!m)
+		return (struct forward_pll_mode *)&si534x_default_mode;
+		//else
+		//	return (struct forward_pll_mode *)&si532x_default_mode_m;
+	}
+
+	/*for (i = 0; i < forward_si532x_modes_count; i++) {
+		const struct forward_si532x_mode *cur = &forward_si532x_modes[i];
+		if ((cur->in_freq == in_freq) && (cur->m == m)) {
+			return (struct forward_pll_mode *)cur;
+		}
+	}*/
+	return NULL;
+}
+
+static int si534x_switch_mode(struct forward_pll *pll, struct forward_pll_mode *mode)
+{
+	struct forward_si534x *si534x = container_of(pll, struct forward_si534x, pll);
+	struct forward_si534x_mode *m = (struct forward_si534x_mode *)mode;
+
+	si534x_write_reg_8(si534x, 0x0B24, 0xC0);
+	si534x_write_reg_8(si534x, 0x0B25, 0x00);
+	si534x_write_reg_8(si534x, 0x0B40, 0x01);
+
+	msleep(300);
+
+	si534x_write_reg_8(si534x, 0x0041, m->oof_div_sel[0]);
+	si534x_write_reg_8(si534x, 0x0042, m->oof_div_sel[1]);
+	si534x_write_reg_8(si534x, 0x0043, m->oof_div_sel[2]);
+
+	si534x_write_reg_32(si534x, 0x005A, m->oof_ratio_ref[0]);
+	si534x_write_reg_32(si534x, 0x005E, m->oof_ratio_ref[1]);
+	si534x_write_reg_32(si534x, 0x0062, m->oof_ratio_ref[2]);
+	si534x_write_reg_32(si534x, 0x00A9, m->lol_clr_delay);
+
+	si534x_write_reg_48(si534x, 0x0208, m->Pn[0]);
+	si534x_write_reg_32(si534x, 0x020E, m->Pd[0]);
+	si534x_write_reg_48(si534x, 0x0212, m->Pn[1]);
+	si534x_write_reg_32(si534x, 0x0218, m->Pd[1]);
+	si534x_write_reg_48(si534x, 0x021C, m->Pn[2]);
+	si534x_write_reg_32(si534x, 0x0222, m->Pd[2]);
+	si534x_write_reg_8(si534x, 0x0230, 0x07);
+
+	si534x_write_reg_48(si534x, 0x0508, m->Bslow);
+	si534x_write_reg_48(si534x, 0x050E, m->Bfast);
+
+	si534x_write_reg_56(si534x, 0x0515, m->Mn);
+	si534x_write_reg_32(si534x, 0x051C, m->Md);
+	si534x_write_reg_32(si534x, 0x0520, 0x1);
+
+	si534x_write_reg_24(si534x, 0x0532, m->hold_15m_cyc_count);
+	si534x_write_reg_16(si534x, 0x0589, m->pfd_en_delay);
+
+	si534x_write_reg_8(si534x, 0x001C, 0x01);
+	si534x_write_reg_8(si534x, 0x0B40, 0x00);
+	si534x_write_reg_8(si534x, 0x0B24, 0xC3);
+	si534x_write_reg_8(si534x, 0x0B25, 0xC2);
+
+	return 0;
+}
+
+static int si534x_select_input(struct forward_pll *pll, int input, bool master, bool autoswitch)
+{
+	struct forward_si534x *si534x = container_of(pll, struct forward_si534x, pll);
+
+	si534x_write_reg_8(si534x, 0x052A, (input << 1) | 0x1);
+
+	if (autoswitch) {
+		switch (input) {
+		case 0:
+			si534x_write_reg_16(si534x, 0x0538, 0x0321);
+			break;
+		case 1:
+			si534x_write_reg_16(si534x, 0x0538, 0x0213);
+			break;
+		case 2:
+			si534x_write_reg_16(si534x, 0x0538, 0x0123);
+			break;
+		}
+		si534x_write_reg_8(si534x, 0x0536, 0x6);
+	} else
+		si534x_write_reg_8(si534x, 0x0536, 0x4);
+
+	si534x_write_reg_8(si534x, 0x0535, master ? 1 : 0);
+
+	return 0;
+}
+
+static int si534x_tune(struct forward_pll *pll, s64 ppt)
+{
+	struct forward_si534x *si534x = container_of(pll, struct forward_si534x, pll);
+	u32 denom = 0xc8000000 + 0xc8000000LL * ppt / 1000000000000LL;
+
+	printk("si534x_tune(): %llu/%llu\n", 0x2328000000ULL, denom);
+
+	si534x_write_reg_48(si534x, 0x302, 0x2328000000ULL);
+	si534x_write_reg_32(si534x, 0x308, denom);
+	si534x_write_reg_48(si534x, 0x30d, 0x2331000000ULL);
+	si534x_write_reg_32(si534x, 0x313, denom);
+	si534x_write_reg_32(si534x, 0x338, 2);
+
+	return 0;
+}
+
+static void si534x_calibrate(struct forward_pll *pll)
+{
+	struct forward_si534x *si534x = container_of(pll, struct forward_si534x, pll);
+	si534x_write_reg_8(si534x, 0x001C, 0x4);
+}
+
+static struct forward_pll_ops si534x_ops = {
+	.find_mode = si534x_find_mode,
+	.switch_mode = si534x_switch_mode,
+	.select_input = si534x_select_input,
+	.tune = si534x_tune,
+	.calibrate = si534x_calibrate,
+};
+
+int forward_si534x_init(struct forward_dev *dev, struct forward_pll **pll, u8 bus, int num_inputs)
+{
+	struct forward_si534x *si534x = kzalloc(sizeof(struct forward_si534x), GFP_KERNEL);
+
+	if (!si534x)
+		return -ENOMEM;
+
+	si534x->pll.dev = dev;
+	si534x->pll.features = FORWARD_PLL_FEATURE_FALLBACK | FORWARD_PLL_FEATURE_MASTER |
+			       FORWARD_PLL_FEATURE_TUNE;
+	si534x->pll.num_inputs = num_inputs;
+	si534x->pll.ops = &si534x_ops;
+	si534x->bus = bus;
+	si534x->bank = 0xFF;
+
+	*pll = &si534x->pll;
+
+	return 0;
+}
+EXPORT_SYMBOL(forward_si534x_init);
+
+void forward_si534x_fini(struct forward_dev *dev, struct forward_pll **pll)
+{
+	if (pll) {
+		struct forward_si534x *si534x = container_of(*pll, struct forward_si534x, pll);
+		kfree(si534x);
+		*pll = NULL;
+	}
+}
+EXPORT_SYMBOL(forward_si534x_fini);
diff --git a/forward/forward-si534x.h b/forward/forward-si534x.h
new file mode 100644
index 0000000..538281d
--- /dev/null
+++ b/forward/forward-si534x.h
@@ -0,0 +1,24 @@
+/*
+   forward-si534x.h - si534x PLL driver for SoftLab-NSK Forward boards
+
+   Copyright (C) 2017 - 2023 Konstantin Oblaukhov <oblaukhov@sl.iae.nsk.su>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License
+   as published by the Free Software Foundation; either version 2
+   of the License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*/
+
+#include "forward-pll.h"
+
+int forward_si534x_init(struct forward_dev *dev, struct forward_pll **pll, u8 bus, int num_inputs);
+void forward_si534x_fini(struct forward_dev *dev, struct forward_pll **pll);
-- 
2.39.1


